// W. B. Langdon cs.bham.ac.uk $Revision: 1.38 $
// This code is released for non-commercial use only
// W.Langdon cs.ucl.ac.uk 

//WBL  5 Aug 2016 Replace fit64 with raw value
//WBL 15 Jul 2016 Add fit64
//WBL 12 Jul 2016 Add exon
//WBL  6 Jun 2016 for ~/gp/eden_mux add INTRON64. For simplificity for INTRON64
//put all opcodes here and dispense with primitive.cxx

#define GP_RUN true
#define EPARITY true
#define BOOL6 true
#ifdef EPARITY
#define Version "MUX cc.64 Problem. $Revision: 1.38 $"
#else
#ifdef BOOL6
#define Version "Bool6 Problem. $Revision: 1.38 $"
#else
#define Version "Bool3 Problem. $Revision: 1.38 $"
#endif
#endif

//Modifications (reverse order):
// WBL 30 Apr 1999 Conversion for SiliconGraphics cc -c -64 -mips4

// WBL  9 Jan 1999 

// WBL 24 Jun 1998  Allow problem_order to be up to 13

// WBL 11 Jun 1998  Add EPARITY

// WBL  9 Mar 1998  Add reading prim.dat

// WBL  3 Mar 1998  based upon r1.35 antprob.cxx and ant.cc r1.29

 
// GPQUICK

#include "pch.h"
#include "chrome.h"
#include "primitiv.h"

#ifdef FASTEVAL
	extern evalnode* IpGlobal;
//	extern Chrome* ChromeGlobal;
#endif

//not used but keeps loader happy
int num_sol_found = 0;//used to report solution to each test phase found

//**************************************************************************
// Define your Problem class

#include <assert.h>
#include "prob.h"
#include "gp.h"
#include "test.h"

//**************************************************************************
// static variables that make up the evaluation environment
// Build your environment here as statics
// where the evaluation functions can get to the data

int problem_order;
int setmaxfit(const ChromeParams* p) {
#ifdef EPARITY
  return pow(2,problem_order)+1; //keep it running for bloat studies
#else
  return 8;
#endif
}//end setmaxfit

#ifndef BOOL6
int frequency[256]; //3 input functions
#else
int trues[8193]; //13 inputs
#ifdef EPARITY
int frequency[8193]; //13 input parity
#else
int frequency[9]; //6 input functions
#endif
BOOL Maj [8192]; //13 input functions
BOOL Mux [8192]; //13 input functions
BOOL Even[8192]; //13 input functions
#endif

//**************************************************************************
// Data handling functions

int current_phase = 0; 
int tests_run = 0;
int tests_apparently_run = 0;
int total_cpu = 0;
test::test(Problem* probl, istream& istr) {}

retval data[13];
BOOL data_limit[13];
retval mux64[4]; /*cc.64*/
//retval mux32[8];


int Reset() {
  memset(trues,0,sizeof(trues));
  memset(frequency,0,sizeof(frequency));
  tests_run = 0;

#ifdef BOOL6
  assert(problem_order<=13);
  memset(data_limit,0,sizeof(data_limit));
  {for(int i=0;i<problem_order;i++) data_limit[i]=1;}
  int i = 0;
  //int i32 = 0; cc.64
  int i64 = 0;
  for(data[12]=0; data[12]<=data_limit[12]; data[12]++)
  for(data[11]=0; data[11]<=data_limit[11]; data[11]++)
  for(data[10]=0; data[10]<=data_limit[10]; data[10]++)
  for(data[9 ]=0; data[9] <=data_limit[9];  data[9]++)
  for(data[8 ]=0; data[8] <=data_limit[8];  data[8]++)
  for(data[7 ]=0; data[7] <=data_limit[7];  data[7]++)
  for(data[6 ]=0; data[6] <=data_limit[6];  data[6]++) {
   retval filter = 1;
   retval target = 0;
   for(data[5 ]=0; data[5] <=data_limit[5];  data[5]++) //cc.64{
//   retval filter = 1;
//   retval target = 0;
  for(data[4 ]=0; data[4] <=data_limit[4];  data[4]++)
  for(data[3 ]=0; data[3] <=data_limit[3];  data[3]++)
  for(data[2 ]=0; data[2] <=data_limit[2];  data[2]++)
  for(data[1 ]=0; data[1] <=data_limit[1];  data[1]++)
  for(data[0 ]=0; data[0] <=data_limit[0];  data[0]++) {
    int sum = 0;
    for(int j=0;j<problem_order;j++) sum += data[j];
    Even[i] = (sum & 1)==0; //Koza GP1 definition
    Maj[i]  = (sum > (problem_order/2))==0; 
    if(problem_order==6) {
    Mux[i]  = (data[5]==0&&data[4]==0)? data[0] :
              (data[5]==0&&data[4]==1)? data[1] :
              (data[5]==1&&data[4]==0)? data[2] : data[3];
    }
    else {
    Mux[i]  = 
              (data[10]==0&&data[9]==0&&data[8]==0)? data[0] :
              (data[10]==0&&data[9]==0&&data[8]==1)? data[1] :
              (data[10]==0&&data[9]==1&&data[8]==0)? data[2] : 
              (data[10]==0&&data[9]==1&&data[8]==1)? data[3] :
              (data[10]==1&&data[9]==0&&data[8]==0)? data[4] :
              (data[10]==1&&data[9]==0&&data[8]==1)? data[5] :
              (data[10]==1&&data[9]==1&&data[8]==0)? data[6] : data[7];
    }
//    cout <<"sum "<<sum<<" ";
//    cout <<"Even["<<i<<"] "<<Even[i];
//    cout <<" Maj["<<i<<"] "<<Maj[i];
    if(Mux[i]) target |= filter;
    filter <<= 1;
    i++;
  }
  //mux32[i32] = target;
  mux64[i64] = target;
#ifndef ALLFUNC_LIB
//   cout <<"\nMux["<<i-1<<".."<<i-32<<"]\t";
//   for(int n=1; n<=32; n++) cout<<Mux[i-n]<<flush;
//   cout <<"\nmux32["<<i32<<"]\t";
//   char buf[80]; sprintf(buf,"%08x\n",mux32[i32]); cout<<buf;
  cout <<"\nMux["<<i-1<<".."<<i-64<<"]\t";
  for(int n=1; n<=64; n++) cout<<Mux[i-n]<<flush;
  cout <<"\nmux64["<<i64<<"]\t";
  char buf[80]; sprintf(buf,"%016lx\n",mux64[i64]); cout<<buf;
#endif
  //i32++;
  i64++;
  }
  cout<<endl; 
  if(problem_order!=6&&problem_order!=11) 
    cout<<"Mux not defined for order "<<problem_order<<endl;
#endif

  //cc.64
//                          /*      least significant           most */
//   data[0] = 0xaaaaaaaa;  /* x0 = 01010101010101010101010101010101 */
//   data[1] = 0xcccccccc;  /* x1 = 00110011001100110011001100110011 */
//   data[2] = 0xf0f0f0f0;  /* x2 = 00001111000011110000111100001111 */
//   data[3] = 0xff00ff00;  /* x3 = 00000000111111110000000011111111 */
//   data[4] = 0xffff0000;  /* x4 = 00000000000000001111111111111111 */

                         /*      least significant           most */
  data[0] = 0xaaaaaaaaaaaaaaaa;  /* x0 = 01010101010101010101010101010101 */
  data[1] = 0xcccccccccccccccc;  /* x1 = 00110011001100110011001100110011 */
  data[2] = 0xf0f0f0f0f0f0f0f0;  /* x2 = 00001111000011110000111100001111 */
  data[3] = 0xff00ff00ff00ff00;  /* x3 = 00000000111111110000000011111111 */
  data[4] = 0xffff0000ffff0000;  /* x4 = 00000000000000001111111111111111 */
  data[5] = 0xffffffff00000000;  /* x0 = */

  //mux64[0]= 0xff00f0f0ccccaaaa;

#ifdef ALLFUNC_LIB
  if(problem_order>4) {
    cout<<"Order exceeds 4 but doing ALLFUNC_LIB\n";
    exit(0);
  }
#endif
  return 0;
}
//////////////////////////  Problem specific functions
#ifdef INTRON64
#ifndef FASTEVAL
error1!
#endif
#ifndef SMC_GP
error2!
#endif
unsigned char intron64[EXPRLEN];
//unsigned char fit64[EXPRLEN];
retval        raw[EXPRLEN];
INT32 chrome64_age;

OPDEF(ConstEval) {/* keep compiler happy ConstEval place holder never called */
  assert(1==0);
}

void Intron64(const evalnode* p0, const evalnode* p1) {
  //can be called multiple times to set overlapping data
  const int ip = (p0-ExprGlobal)+1; //p0 will be incremented before use
  const int treesize = p1-p0;
  memset(&intron64[ip],1,treesize*sizeof(unsigned char));
}

/*inline unsigned long Fit64(const evalnode* p0, const unsigned long result) {
  //ugly hack nick stuff from bool.test.64 r1.11
  int fit = 0;
  const int i64 = 0;
  const retval matches = ~(result ^ (mux64[i64])); // Find bits where TARGET = RESULT
  retval filter = 1; 
  for(int i = 0; i < 64; i ++ )    //Count bits set in MATCHES
    {
      if(  matches & filter   ) fit ++; 
      filter <<= 1; 
    }
  //end bool.test.64 r1.11

  assert(fit>=0 && fit <=64);
  const int ip = (p0-ExprGlobal);
  assert(ip>=0 && ip < EXPRLEN);
  fit64[ip] = fit;
  return result;
}*/

inline retval Raw(const evalnode* p0, const retval result) {
  /*ugly hack nick stuff from bool.test.64 r1.11*/
  const int ip = (p0-ExprGlobal);
  assert(ip>=0 && ip < EXPRLEN);
  raw[ip] = result;
  return result;
}

//#define OPDEF2(f) {const evalnode* p0 = IP; return Fit64(p0,f());}
  #define OPDEF2(f) {const evalnode* p0 = IP; return   Raw(p0,f());}

OPDEF(AndEval_)  {    /* Bitwise AND cc.64 */
  const evalnode* p0 = IP;
  const retval a1 = EVAL;
  const evalnode* p1 = IP;
  const retval a2 = EVAL;
  const evalnode* p2 = IP;
  if(a2 == 0) Intron64(p0,p1);
  if(a1 == 0) Intron64(p1,p2);
  return (a1 & a2); }

OPDEF(NandEval_)  {    /* Bitwise NAND cc.64 */
  const evalnode* p0 = IP;
  return ~AndEval(); }

OPDEF(OrEval_)  {    /* Bitwise OR cc.64 */
  const evalnode* p0 = IP;
  const retval a1 = EVAL;
  const evalnode* p1 = IP;
  const retval a2 = EVAL;
  const evalnode* p2 = IP;
  if(a2 == ~0) Intron64(p0,p1);
  if(a1 == ~0) Intron64(p1,p2);
  return (a1 | a2); }

OPDEF(NorEval_)  {    /* Bitwise NOR cc.64 */
  return ~OrEval(); }

OPDEF(AndEval)  OPDEF2(AndEval_)
OPDEF(NandEval) OPDEF2(NandEval_)
OPDEF(OrEval)   OPDEF2(OrEval_)
OPDEF(NorEval)  OPDEF2(NorEval_)



char* Function::getprint(Chrome* chrome, const int ip, char* scratch) { //based on chrome.cxx r1.169
  if(chrome64_age != chrome->birth) return name; //else intron64 and fit64 ok, so modify text
  const int len = strlen(name); assert(len<100);
  for(int i=0;i<len;i++) scratch[i] = name[i] | (intron64[ip]? 0x20 : 0);
  //if(name[0]!='D') sprintf(&scratch[len],"_%d",fit64[ip]);
  if(name[0]!='D') sprintf(&scratch[len],"_%lX",raw[ip]);
  else scratch[len] = '\0'; //fit64 and raw not set on leafs
  return scratch;
}
#else /*INTRON64*/

#ifdef FASTTRAVERSE
OPDEF(NandEval) {
	if(!EVAL) {
	  IP++;
	  TRAVERSE();    // Jump the second expression
	  IP--;          // Back up for EVAL
	  return 1;
	}
	return !EVAL;
      }
#else
#ifdef SMC_GP
//OPDEF(NandEval) {return ~((retval (EVAL)) & (retval (EVAL))); }   /* Bitwise NAND  */
OPDEF(NandEval) {    /* Bitwise NAND cc.64 */
  const retval a1 = EVAL;
  const retval a2 = EVAL;
  return ~(a1 & a2); }
#else
OPDEF(NandEval) {const BOOL a1=EVAL; const BOOL a2=EVAL; return !(a1 && a2); }
#endif
#endif /*FASTTRAVERSE*/
#ifdef FASTTRAVERSE
OPDEF(NorEval) {
	if(EVAL) {
	  IP++;
	  TRAVERSE();    // Jump the second expression
	  IP--;          // Back up for EVAL
	  return 0;
	}
	return !EVAL;
      }
#else
#ifdef SMC_GP
//OPDEF(NorEval)  {return ~((EVAL) | (EVAL)); }   /* Bitwise NOR  */
OPDEF(NorEval)  {    /* Bitwise NOR cc.64 */
  const retval a1 = EVAL;
  const retval a2 = EVAL;
  return ~(a1 | a2); }
#else
OPDEF(NorEval)  {const BOOL a1=EVAL; const BOOL a2=EVAL; return !(a1 || a2); }
#endif
#endif /*FASTTRAVERSE*/

#endif /*INTRON64*/

#ifdef SMC_GP
//OPDEF(EqEval)   { return ~((EVAL) ^ (EVAL)); }   /* Bitwise EQ */
OPDEF(EqEval)   { /* Bitwise EQ cc.64 */
  const retval a1 = EVAL;
  const retval a2 = EVAL;
  return ~(a1 ^ a2); }   
#else
OPDEF(EqEval)   { return   EVAL == EVAL;  }
#endif
#ifdef SMC_GP
//OPDEF(XorEval)  { return (EVAL) ^ (EVAL); }   /* Bitwise XOR */
OPDEF(XorEval)  { /* Bitwise XOR cc.64 */
  const retval a1 = EVAL;
  const retval a2 = EVAL;
  return a1 ^ a2; }
#else
OPDEF(XorEval)  { return !(EVAL == EVAL); }
#endif


OPDEF(D0Eval)  { return data[0]; }
OPDEF(D1Eval)  { return data[1]; }
OPDEF(D2Eval)  { return data[2]; }
OPDEF(D3Eval)  { return data[3]; }
OPDEF(D4Eval)  { return data[4]; }
OPDEF(D5Eval)  { return data[5]; }
OPDEF(D6Eval)  { return data[6]; }
OPDEF(D7Eval)  { return data[7]; }
OPDEF(D8Eval)  { return data[8]; }
OPDEF(D9Eval)  { return data[9]; }
OPDEF(D10Eval) { return data[10]; }
OPDEF(D11Eval) { return data[11]; }
OPDEF(D12Eval) { return data[12]; }

OPDEF(FalseEval) { return 0; }
OPDEF(TrueEval)  { return ~0; }

//**************************************************************************
///////////////////////// Read Terminal and Function sets form file

//taken form ant.cc r1.29

BOOL firstline = TRUE;
void getline(istream& in, char* buffer,const int size, const int delim='\n')
{
BOOL rval;
do {
rval = TRUE;
int n = 0;
char ch;
//cout<<"getline"<<flush;
for(; (ch = in.get())!=delim && !in.rdstate(); ) {
  //cout<<" "<<in.rdstate()<<flush;
  if(n<size-1) buffer[n++] = ch;
  else rval = FALSE;
}
buffer[n] = '\0';
//cout<<" "<<n<<flush;
if(firstline) {
  firstline = FALSE;
  cout<<buffer<<endl;
}
} while(buffer[0]=='%');

if(!rval) cout<<"ERROR line `"<<buffer<<"' exceeds "<<size<<endl;
}//end getline

BOOL inline layout(const char c) { return (c==' '||c=='\t');}

//**************************************************************************
///////////////////////// PROBLEM definition

void gp::AddFall (Function* f )
{
AddF(f);
for ( int i = 0; i < NUM_TREES; i++ )
	addtofuncbag(i, f);
}


gp::gp() : Problem()
{
	ProbVersion = Version;
	assert ( NUM_TREES >= NUM_OPERATIONS );
	AddFall(new ConstFunc(0));  // Required for GPQUICK, but zero weight

  ifstream inf("prim.dat");
  if (!inf) {
    cout<<"ERROR cannot open prim.dat\n";
    exit(0);
  }

  char buffer[1023+1]; //printing chars + \0
  char copy[1023+1];

  do {
    getline(inf,buffer,sizeof(buffer));
    if(inf.rdstate()) break; //exit loop on ios::eof etc

    char* ibuff = &buffer[0];
    do {
      for(;(*ibuff!='\0')&&layout(*ibuff);ibuff++); //skip layout
      char* c = &copy[0];
      for(;(*ibuff!='\0')&&!layout(*ibuff);ibuff++) *c++=*ibuff; *c++='\0';

if     (strcmp(copy,""   )==0) break;
#ifndef INTRON64
else if(strcmp(copy,"IF" )==0) AddFall(new IfFunc(100));
#endif
else if(strcmp(copy,"AND")==0) AddFall(new AndFunc(100)); 
else if(strcmp(copy,"OR" )==0) AddFall(new OrFunc(100));
else if(strcmp(copy,"NAND")==0)AddFall(new Function(2,0,100,NandEval,"NAND"));
else if(strcmp(copy,"NOR" )==0)AddFall(new Function(2,0,100,NorEval, "NOR"));
else if(strcmp(copy,"XOR" )==0)AddFall(new Function(2,0,100,XorEval, "XOR"));
else if(strcmp(copy,"EQ" )==0) AddFall(new Function(2,0,100,EqEval,  "EQ"));
#ifndef INTRON64
else if(strcmp(copy,"NOT")==0) AddFall(new NotFunc(100)); 
#endif
else if(strcmp(copy,"D0" )==0) AddFall(new Function(0,0,100,D0Eval,  "D0"));
else if(strcmp(copy,"D1" )==0) AddFall(new Function(0,0,100,D1Eval,  "D1"));
else if(strcmp(copy,"D2" )==0) AddFall(new Function(0,0,100,D2Eval,  "D2"));
else if(strcmp(copy,"D3" )==0) AddFall(new Function(0,0,100,D3Eval,  "D3"));
else if(strcmp(copy,"D4" )==0) AddFall(new Function(0,0,100,D4Eval,  "D4"));
else if(strcmp(copy,"D5" )==0) AddFall(new Function(0,0,100,D5Eval,  "D5"));
else if(strcmp(copy,"D6" )==0) AddFall(new Function(0,0,100,D6Eval,  "D6"));
else if(strcmp(copy,"D7" )==0) AddFall(new Function(0,0,100,D7Eval,  "D7"));
else if(strcmp(copy,"D8" )==0) AddFall(new Function(0,0,100,D8Eval,  "D8"));
else if(strcmp(copy,"D9" )==0) AddFall(new Function(0,0,100,D9Eval,  "D9"));
else if(strcmp(copy,"D10")==0) AddFall(new Function(0,0,100,D10Eval, "D10"));
else if(strcmp(copy,"D11")==0) AddFall(new Function(0,0,100,D11Eval, "D11"));
else if(strcmp(copy,"D12")==0) AddFall(new Function(0,0,100,D12Eval, "D12"));
else if(strcmp(copy,"TRUE")==0) AddFall(new Function(0,0,100,TrueEval,"TRUE"));
else if(strcmp(copy,"FALSE")==0)AddFall(new Function(0,0,100,FalseEval,"FALSE"));
else {cout<<"unknown function "<<copy<<endl;}
} while(TRUE); //end do
} while(TRUE); //end do

	cout<<"\n% OPs ";
	problem_order = 0;
	for (int j=1;j<funccount;j++) {//ignore ConstFunc(0)
	  cout<<funclist[j]->getname()<<" "<<flush;
	  if(funclist[j]->argnum==0 && *(funclist[j]->getname())=='D') 
	    problem_order++;
	}
	cout<<" order "<<problem_order<<" "<<flush;
	//cout<<endl;

	// If you need to load problem specific data for Evaluation
	// Or load an environment (a map, a scenario)
	// Do it here
	Reset();
}

#ifdef BOOL6
/***********************************************************************/
float stub_fitness(Chrome* chrome)  // fitness function.
{
#include "bool.test64.cc"
}
float gp::fitness(Chrome* chrome)  // fitness function.
{
  const float retval = stub_fitness(chrome);

#ifdef INTRON64
#if NUM_TREES != 1
Error here and DisplayZStats assumes one tree
#endif
  const int size = chrome->SubLen(0);
  int exon = 0;
  int nsol = 0;

  for(int i=0;i<size;i++) {
    if(intron64[i]==0) exon++;
    //if(fit64[i]==64)   nsol++;
    if(raw[i]==mux64[0]) nsol++;
  }
  chrome->nfitness->exon = exon;
  chrome->nfitness->nsol = nsol;
#endif /*INTRON64*/
  return retval;
}//end gp::fitness

float display_run0(Chrome* chrome, const int gencount) {
#define DISPLAY
#include "bool.test64.cc"
#undef DISPLAY
}
float display_run(Chrome* chrome, const int gencount) {
  cout << "\nExecuting "<< chrome << flush;
  chrome->write(PRETTY_NONE); cout<<endl;

  chrome->SetupEval();

  display_run0(chrome, gencount);

  //last leaf did not increment IP but needs to be included
  //const int treesize = (IP-ExprGlobal)+1;
  //for(int ip=0;ip<treesize; ip++) printf("%s",intron64[ip]? "i" : "_");
  //printf("#%d intron64\n",treesize);
}
#else
/***********************************************************************/
int test8(Chrome* chrome) 
{
//Assume for the timebeing we are going to be dealing with all functions of 
//three arguments 

  int test = 1;
  int answer = 0;
  for(data[0]=0; data[0]<=1; data[0]++)
  for(data[1]=0; data[1]<=1; data[1]++)
  for(data[2]=0; data[2]<=1; data[2]++) {
    tests_run++;
    answer += chrome->evalAll(0)*test;
    test *= 2;
  }
  return answer;

}//end test8

float gp::fitness(Chrome* chrome)  // fitness function.
{
  const int answer = test8(chrome);
  frequency[answer]++;

  chrome->nfitness->fvalue = (answer==150)? 7 :    //Odd 3 parity
                             (answer==105)? 8 : 0; //Even 3 parity
  return chrome->nfitness->fvalue;

}//end gp::fitness

float display_run(Chrome* chrome) {
  cout << "\nExecuting "<< chrome << flush;
  chrome->write(PRETTY_NONE); cout<<endl;

  chrome->SetupEval();

  const int answer = test8(chrome);

  char buf[80]; sprintf(buf,"%0X",answer);
  cout<<"8 results "<<answer<<" = "<<buf<<" (hex)\n";

  return 0;
}
#endif /*BOOL6*/
/***********************************************************************/

void test::write_stats(ostream& out) const
{
out<<"Ran " << tests_run << " trees. " << endl;
}//end write_stats

void write_problem_params()
{
//cout<<store_limit<<"["<<Array_bot<<".."<<Array_top<<"] ";
//cout<<mem_penalty_bot<<" "
  cout << "max fitness "<<max_fitness;
#ifdef TIMINGS
//  cout<<" "<<cpu_penalty_bot<<;
#endif
  cout<<endl;
}


// Define your FitnessValue class

void myfitnessvalue::write(ostream& fout)
{	fout << fvalue;
#ifdef MINC_ADF
	fout << " adf1ver " << adf1;
#endif
#ifdef TIMINGS
	fout << " cpu " << cpu_time;
#endif
//	fout << " Same " << Ntests_run;
#ifdef TRACE_RUN
	fout << " (";

	int notrun[NUM_TREES];
	missed(this, notrun);

	for (i=0; i < NUM_TREES; i++)
		{ char buf[80]; 
		  sprintf(buf,"%4d", ok(i)); fout << buf;
		  {if(Tree_OK(this,i))
			   fout<<"K"; else fout<<"-";}
		  sprintf(buf,"%-4d",nak(i)); fout << buf;
		  sprintf(buf,"%-4d",notrun[i]); fout << buf;		  
	        }
	fout << ")";
#endif
}//end myfitnessvalue::write

void cache_init()
{
}

void cache_stats_init()
{
}

void cache_stats()
{
}

//**************************************************************************
///////////////////////// PROBLEM definition

void gp::LoadTests(istream& in)
{ 
}

void gp::WriteTreeName(int tree, ostream& ostr)
{ostr<< "bool";
}//end queue::WriteTreeName()

BOOL gp::TreeNameMatch(int tree, char* s)
{return 0; //any string will do
}//end gp::TreeNameMatch()

int static_check_loop_check = 0;
int gp::static_check(Chrome* chrome, int tree)
// Perform static analysis of new chromsome. Just changed in tree
{
return 0; //Uncomment to disable static_check//ie ok
}//end queue::static_check


void gp::write_stats(ostream& out)
{
#ifndef GP_RUN
cout<<"Frequency of TRUE\ntimes count\n";
{for(int i=0; i<=pow(2,problem_order); i++)
  cout<<i<<" ; "<<trues[i]<<endl;}
cout<<"Frequency of rules\nrule count\n";
{for(int i=0; i<=pow(2,problem_order); i++)
  cout<<i<<" : "<<frequency[i]<<endl;}
#endif /*GP_RUN*/
}

retval random_value(int& seed) //seed must be > 0
{
//return retval(F_tan_spread*tan(float(intrnd(seed) % 3141)/1000.0));
return retval(intrnd(seed)); //default -- not used
}

void myfitnessvalue::clear()
{
//NB clearing whole of myfitnessclass cause gcc produced code to crash

//In theory dont need to do this most of the time since on copy or
//crossover will soon be overwritten with data from parent

//cout<<"Sizeof myfitnessvalue "<<sizeof(*this)<<endl;

}

int mincpu_found; //lowest cpu used by any solution reported so far


int end_gens()
{
	//we never move on to next test phase
	return 0;
}//end_gens


int Chrome::ChooseCrossTree(Chrome* second_parent) {
//not actually in use
return rnd(NUM_TREES);
} //end Chrome::ChooseCrossTree


#ifdef MAXTREEDEPTH
void gp::ProbLPStats(int f[][NUM_TREES][MAXTREEDEPTH+1], int pcount[pcount_size] ) 
#else
void gp::ProbLPStats(int f[][NUM_TREES], int pcount[pcount_size] ) 
#endif /*MAXTREEDEPTH*/
{
pcount[0] += 1;//not used
pcount[1] += 1;//not used
pcount[2] += 1;//not used
pcount[3] += 1;//not used

}//end ProbLPStats

int gp::ProbLTStat(int tree, int start, int length, node* expr )
{
return -1; //ignore
}//end ProbLTStat

